; GUI #
include win64a.inc
includelib IPC.lib
ExeToDll PROTO :qword,:dword,:dword
DllToExe PROTO :qword,:dword,:dword
IDC_DIALOG	equ 200
ID_TXT		equ 100
ID_ICON		equ 102
IDC_ICON1	equ 500

.code
WinMain proc dummy:qword

        invoke  DialogBoxParamA,IMAGE_BASE,IDC_DIALOG,HWND_DESKTOP,qword ptr(offset DialogProc),0
        invoke  RtlExitUserProcess,NULL
WinMain endp
DialogProc proc hWnddlg:qword,msg:qword,wParam:qword,lParam:qword
local	p:qword
local	FSize:dword
local	lpwiocb:WAVEHDR
local	hWaveOut:qword

	mov	hWnddlg,rcx
	mov	lParam,r9

	cmp	edx,WM_CLOSE
	je	wmCLOSE
	cmp	edx,WM_USER+1
	je	wmUSER_1
	cmp	edx,WM_COMMAND
	je	wmCOMMAND
        cmp 	edx,WM_INITDIALOG
	jne	wmBYE

wmINITDIALOG:;mov rcx,hWnd
;   
        invoke  FindWindowA,0,&szWin
        or      eax,eax
        jnz	wmBYE
	invoke	MessageBoxA,hWnddlg,&Error1,&szAppName,MB_ICONEXCLAMATION or MB_YESNO
	cmp	eax,IDNO
	jz      wmBYE      
	invoke	WinExec,&szService,SW_SHOW
	jmp	wmBYE
wmUSER_1:cmp	r9b,CF_TEXT
	je	COPY_TEXT
	cmp     r9b,CF_BITMAP;    ?
	je	COPY_ICON
        cmp     r9b,CF_WAVE
        jne	wmBYE
	shr	r9,8
	mov	FSize,r9d
	invoke	DllToExe
	mov	p,rax
	mov	r8,p
;"RIFF"+(File size)+(File Type Header)+(Format chunk marker)+(Length of format data) = 14h
        add	r8d,14h
        invoke	waveOutOpen,&hWaveOut,WAVE_MAPPER,,0,0,WAVE_ALLOWSYNC
;    
	lea	edi,lpwiocb
	mov	edx,edi
	xor	eax,eax
	mov	ecx,(sizeof WAVEHDR)/8
	rep	stosq
	mov	rax,p
;"RIFF"+(File size)+(File Type Header)+(Format chunk marker)+(Length of format data)+\
;(Type of format)+(Number of Channels)+(Sample Rate)+(Sample Rate*BitsPerSample*Channels/8)+\
;(BitsPerSample*Channels/8)+(Bits per sample)+(data chunk header)+(Size of the data section)=2Ch
	add	rax,2Ch
	mov	[rdx].WAVEHDR.lpData,rax ;  
	mov	eax,FSize
	sub	eax,2Ch
	mov	[rdx].WAVEHDR.dwBufferLength,eax ;  
	invoke	waveOutPrepareHeader,hWaveOut,,sizeof WAVEHDR
;   
	invoke	waveOutWrite,hWaveOut,&lpwiocb,sizeof WAVEHDR
@@:	test	lpwiocb.dwFlags,WHDR_DONE
	jz	@b
	invoke	waveOutUnprepareHeader,hWaveOut,&lpwiocb,sizeof WAVEHDR
	invoke	waveOutClose,hWaveOut
	jmp	wmBYE
COPY_TEXT:invoke DllToExe
	invoke	SetDlgItemTextA,hWnddlg,ID_TXT,eax
	jmp	wmBYE
COPY_ICON:shr	r9,8
	mov	FSize,r9d
	invoke	DllToExe
;  HICON   
	invoke  CreateIconFromResourceEx,eax,FSize,TRUE,30000h,256,256,LR_DEFAULTCOLOR
	invoke  SendDlgItemMessageA,hWnddlg,ID_ICON,STM_SETIMAGE,IMAGE_ICON,eax
	jmp	wmBYE
wmCOMMAND:cmp	r8d,BN_CLICKED shl 16 + IDCANCEL
	jne	wmBYE
wmCLOSE:invoke	EndDialog,,0	
wmBYE:	xor eax,eax
	leave
	retn
DialogProc endp
.data
szWin	  db "DLL Sender",0
Error1	  db "The server is not running.",10,"Run?",0
szAppName db "DLL Reciever",0
szService db "15s",0
ClassName db 'DLGCLASS',0
end 